CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
                                                                          


OBJ

  Dbg    : "FullDuplexSerialPlus"   'From Parallax Inc.
  Str    : "stringEngine"                                   'Propeller Education Kit
  IMU    : "FullDuplexSerialPlus"

VAR


  byte IMU_buff[23],Rx, i
  long cptr, ptr, arg, j
  long IMU_Point[20], Null[1]
  long roll
  
Pub Main

Null[0] := 0

IMU.start(17,16, 0, 38400)

waitcnt(clkfreq/4 + cnt)

Dbg.Start(31, 30, 0, 57600)

waitcnt(clkfreq/4 + cnt)
Dbg.Str(string("running"))
repeat
  
  i:=0
  bytefill(@IMU_buff,0,23)
  repeat while Rx <>= "D"                ' wait for the ! to insure we are starting with
     Rx := IMU.rx                        '   a complete sentence 
  
  if IMU.rx=="W" 

    repeat while i<22                 '  continue to collect data until the end of the sentence 
       IMU_buff[i]:= IMU.rx
       i++
    bytemove (@roll,IMU_buff[3],2)
     
    str.binaryToNumber(@roll)
    'roll:=roll/100
    dbg.dec(roll)
    Dbg.Str(string(10, 13))


pub copy_buffer ( buffer,args)   'copy_buffer(@IMU_buff, @IMU_Point)
         'bytemove(buffer,@gps_buff,cptr) '  copy received data to buffer
         ptr := buffer
         arg := 0
         repeat j from 0 to 78           ' build array of pointers
          if byte[ptr] == 0               ' to each
             if byte[ptr+1] == 0           ' record
                long[args][arg] := Null     ' in 
             else                            ' the
                long[args][arg] := ptr+1     ' data buffer
             arg++
          ptr++
          
' now we just need to return the pointer to the desired record


pub RLL
   return IMU_Point[0]
pub PCH
   return IMU_Point[1]
pub YAW
   return IMU_Point[2]
pub LAT
   return IMU_Point[3]
pub LON
   return IMU_Point[4]
pub ALT
   return IMU_Point[5]
pub CRS
   return IMU_Point[6]
pub SPD
   return IMU_Point[7]
pub FIX
   return IMU_Point[8]

{'Use this code for ArduIMU pre installed software
pub AN1
   return IMU_Point[0]
pub AN2
   return IMU_Point[1]
pub AN3
   return IMU_Point[2]
pub AN4
   return IMU_Point[3]
pub AN5
   return IMU_Point[4]
pub RLL
   return IMU_Point[5]
pub PCH
   return IMU_Point[6]
pub YAW
   return IMU_Point[7]
}